import numpy as np
import matplotlib.pyplot as plt
import math

def f1(x):
    return 5/((2 * x ** 2 ) ** (1/3))

def f2(x):
    return 10 ** 5 * (2 * np.e) ** (-x/100)

def f3(x):
    x2 = 2 * x
    x10_2x = math.pow(10,x2)
    x5 = 5 * x
    x2_5x = math.pow(2, x5)
    x10_2x_x2_5x = x10_2x / x2_5x
    y = math.pow(x10_2x_x2_5x, 2)
    return y
xstep = 1
xstart = xstep
xstop = 100
x = np.arange(xstart, xstop + xstep, xstep)

# Aufgabe (i)
y1 = [f1(x_value) for x_value in x]
plt.plot(x, y1, label="f1(x)")
# Beide Achsen logarithmisch
plt.xscale('log', base = 2)
plt.yscale('log', base = 2)
# Steigung: -2/3
# Y-Achsenabschnitt: 0
plt.grid()
plt.title("(i)")
plt.figure()


# Aufgabe (ii)
y2 = [f2(x_value) for x_value in x]
plt.plot(x, y2, label="f2(x)")
# Y - Achse logarithmisch
plt.yscale('log', base = np.e)
# Steigung: -1/3
# Y-Achsenabschnitt: 100000
plt.grid()
plt.title("(ii)")
plt.figure()


# Aufgabe (iii)
y3 = [f3(x_value) for x_value in x]
plt.plot(x, y3, label="f3(x)")
# Y - Achse logarithmisch
plt.yscale('log', base = 10)
# Steigung: 1
# Y-Achsenabschnitt: 100000
plt.grid()
plt.title("(iii)")

plt.show()